/**
 *******************************************************************************
 * @file    dpm32m0xx_it.h
 *
 * @brief   Interrupt service routines.
 *
 * @author  DPM
 *
 * @version V1.0.0, firmware update for DPM32M08x
 *
 * @date    2024-05-16
 *******************************************************************************/

/*
    Copyright (c) 2024, DP Microelectronics Inc.

    Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

    1. Redistributions of source code must retain the above copyright notice, this
       list of conditions and the following disclaimer.
    2. Redistributions in binary form must reproduce the above copyright notice,
       this list of conditions and the following disclaimer in the documentation
       and/or other materials provided with the distribution.
    3. Neither the name of the copyright holder nor the names of its contributors
       may be used to endorse or promote products derived from this software without
       specific prior written permission.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
OF SUCH DAMAGE.
*/

#include "dpm32m0xx_it.h"

extern void IncTick(void);

extern uint8_t  int_flag_cnt_rxne;
extern uint8_t  int_flag_cnt_txe;
extern uint8_t  int_flag_cnt_stop;
extern uint8_t  int_flag_cnt_start;
extern uint8_t  int_flag_cnt_match;
extern uint8_t tx_buf[5];
extern uint8_t rx_buf[5];

/**
 * @brief  This function handles NMI exception.
 * @param  None
 * @retval None
 */
void NMI_Handler(void)
{
  /* if NMI exception occurs, go to infinite loop */
  while(1)
  {
  }
}

/**
 * @brief  This function handles Hard Fault exception.
 * @param  None
 * @retval None
 */
void HardFault_Handler(void)
{
  /* if Hard Fault exception occurs, go to infinite loop */
  while(1)
  {
  }
}

/**
 * @brief  This function handles SVCall exception.
 * @param  None
 * @retval None
 */
void SVC_Handler(void)
{
  /* if SVC exception occurs, go to infinite loop */
  while(1)
  {
  }
}

/**
 * @brief  This function handles PendSVC exception.
 * @param  None
 * @retval None
 */
void PendSV_Handler(void)
{
  /* if PendSV exception occurs, go to infinite loop */
  while(1)
  {
  }
}

/**
 * @brief  This function handles SysTick Handler.
 * @param  None
 * @retval None
 */
void SysTick_Handler(void)
{
  IncTick();
}

/**
 * @brief  Reports the name of the source file and the source line number
 *         where the assert_param error has occurred.
 * @param  file: pointer to the source file name
 * @param  line: assert_param error line source number
 * @retval None
 */
void Param_AssertHandler(uint8_t *file, int16_t line)
{
  /* Users can add file names and line numbers to implement assertion reporting.
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
}

/******************************************************************************/
/*                 DPM32M0XX Peripherals Interrupt Handlers                   */
/*  Add here the Interrupt Handler for the used peripheral(s) (PPP), for the  */
/*  available peripheral interrupt handler's name please refer to the startup */
/*  file (startup_dpm32m0xx.s).                                               */
/******************************************************************************/

/**
 * @brief  This function handles PPP interrupt request.
 * @param  None
 * @retval None
 */
/*void PPP_IRQHandler(void)
{
}*/

/**
 * @}
 */

/**
 * @}
 */

/**
  * @}
  */

/**
  * @}
  */
/**
  * @brief  This function handles I2C interrupt Handler.
  * @param  None
  * @retval None
  */
void I2C_IRQHandler(void)
{
  if(I2C_GetIntFlagStatus(I2C_INT_FLAG_STARTF) != RESET)
  {
    I2C_ClearIntFlag(I2C_INT_FLAG_STARTF);
    int_flag_cnt_start ++;
  }

  if(I2C_GetIntFlagStatus(I2C_INT_FLAG_STOPF) != RESET)
  {
    I2C_ClearIntFlag(I2C_INT_FLAG_STOPF);
    int_flag_cnt_stop ++;
  }

  if(I2C_GetIntFlagStatus(I2C_INT_FLAG_TXE) != RESET)
  {
    if(int_flag_cnt_txe < 5)
    {
      I2C_SendData(tx_buf[int_flag_cnt_txe]);
    }

    int_flag_cnt_txe++;
    I2C_ClearIntFlag(I2C_INT_FLAG_TXE);
  }

  if(I2C_GetIntFlagStatus(I2C_INT_FLAG_RXNE) != RESET)
  {
    if(int_flag_cnt_rxne < 5)
    {
      rx_buf[int_flag_cnt_rxne] = I2C_ReceiveData();
    }

    int_flag_cnt_rxne++;
    I2C_ClearIntFlag(I2C_INT_FLAG_RXNE);
  }
  
    if(I2C_GetIntFlagStatus(I2C_INT_FLAG_ADDRM) != RESET)
    {
        I2C_ClearIntFlag(I2C_INT_FLAG_ADDRM);
        int_flag_cnt_match++;
    }
}
